#!/bin/bash
# fc4upd.sh

# ű: Frank Wang.
# ޸.
# Ȩڱʹ.


#  ʹrsyncӾվFedora 4ĸ. 
#  Ϊ˽ʡռ, ж汾ڵĻ, 
#+ ֻµİ. 

URL=rsync://distro.ibiblio.org/fedora-linux-core/updates/
# URL=rsync://ftp.kddilabs.jp/fedora/core/updates/
# URL=rsync://rsync.planetmirror.com/fedora-linux-core/updates/

DEST=${1:-/var/www/html/fedora/updates/}
LOG=/tmp/repo-update-$(/bin/date +%Y-%m-%d).txt
PID_FILE=/var/run/${0##*/}.pid

E_RETURN=65        # ĳЩ벻Ĵ.


# һrsyncѡ
# -r: ݹ
# -t: ʱ
# -v: verbose

OPTS="-rtv --delete-excluded --delete-after --partial"

# rsync includeģʽ
# ͷ"/"ᵼ¾·ƥ. 
INCLUDE=(
    "/4/i386/kde-i18n-Chinese*" 
#   ^                         ^
# ˫Ǳ, ֹglobbing.
) 


# rsync excludeģʽ
# ʹ"#"ʱע͵һЩҪİ.
EXCLUDE=(
    /1
    /2
    /3
    /testing
    /4/SRPMS
    /4/ppc
    /4/x86_64
    /4/i386/debug
   "/4/i386/kde-i18n-*"
   "/4/i386/openoffice.org-langpack-*"
   "/4/i386/*i586.rpm"
   "/4/i386/GFS-*"
   "/4/i386/cman-*"
   "/4/i386/dlm-*"
   "/4/i386/gnbd-*"
   "/4/i386/kernel-smp*"
#  "/4/i386/kernel-xen*" 
#  "/4/i386/xen-*" 
)


init () {
    # ùܵؿܵrsync, , ʱ(stalled network).
    set -o pipefail

    TMP=${TMPDIR:-/tmp}/${0##*/}.$$     # 澫б.
    trap "{                                                   
        rm -f $TMP 2>/dev/null                                
    }" EXIT                             # ɾڵʱļ.
}


check_pid () {
# Ƿ. 
    if [ -s "$PID_FILE" ]; then
        echo "PID file exists. Checking ..."
        PID=$(/bin/egrep -o "^[[:digit:]]+" $PID_FILE)
        if /bin/ps --pid $PID &>/dev/null; then
            echo "Process $PID found. ${0##*/} seems to be running!"
           /usr/bin/logger -t ${0##*/} \
                 "Process $PID found. ${0##*/} seems to be running!"
            exit $E_RETURN
        fi
        echo "Process $PID not found. Start new process . . ."
    fi
}


#  ϱߵģʽ,
#+ ļĸ·Χ, root$URLʼ.
set_range () {
    include=
    exclude=
    for p in "${INCLUDE[@]}"; do
        include="$include --include \"$p\""
    done

    for p in "${EXCLUDE[@]}"; do
        exclude="$exclude --exclude \"$p\""
    done
}


# òrsyncб.
get_list () {
    echo $$ > $PID_FILE || {
        echo "Can't write to pid file $PID_FILE"
        exit $E_RETURN
    }

    echo -n "Retrieving and refining update list . . ."

    # б -- ΪrsyncĻҪ'eval'.
    # $3$4ļںʱ.
    # $5İ.
    previous=
    pre_file=
    pre_date=0
    eval /bin/nice /usr/bin/rsync \
        -r $include $exclude $URL | \
        egrep '^dr.x|^-r' | \
        awk '{print $3, $4, $5}' | \
        sort -k3 | \
        { while read line; do
            # е, ˵õİ. 
            cur_date=$(date -d "$(echo $line | awk '{print $1, $2}')" +%s)
            #  echo $cur_date

            # ȡļ. 
            cur_file=$(echo $line | awk '{print $3}')
            #  echo $cur_file

            # ܵĻ, ļȡrpmİ. 
            if [[ $cur_file == *rpm ]]; then
                pkg_name=$(echo $cur_file | sed -r -e \
                    's/(^([^_-]+[_-])+)[[:digit:]]+\..*[_-].*$/\1/')
            else
                pkg_name=
            fi
            # echo $pkg_name

            if [ -z "$pkg_name" ]; then   #  һrpmļ,
                echo $cur_file >> $TMP    #+ Ȼӵб.
            elif [ "$pkg_name" != "$previous" ]; then   # һ°.
                echo $pre_file >> $TMP                  # µļ.
                previous=$pkg_name                      # 浱ǰ״̬.
                pre_date=$cur_date
                pre_file=$cur_file
            elif [ "$cur_date" -gt "$pre_date" ]; then  #  ͬİ, һЩ, 
                pre_date=$cur_date                      #+ ô͸µ. 
                pre_file=$cur_file
            fi
            done
            echo $pre_file >> $TMP                      #  TMPڰ
                                                        #+ б. 
            # echo "subshell=$BASH_SUBSHELL"

    }       # ĴΪ"echo $pre_file >> $TMP"
            # Ҳѭһŵͬһshell ( 1 ). 

    RET=$?  # ȡùܵķ״̬. 

    [ "$RET" -ne 0 ] && {
        echo "List retrieving failed with code $RET"
        exit $E_RETURN
    }

    echo "done"; echo
}

# rsyncز. 
get_file () {

    echo "Downloading..."
    /bin/nice /usr/bin/rsync \
        $OPTS \
        --filter "merge,+/ $TMP" \
        --exclude '*'  \
        $URL $DEST     \
        | /usr/bin/tee $LOG

    RET=$?

        #  --filter merge,+/ Ŀ˵, Ҫ. 
        #  + ΪŰ, / ζž·. 
        #  Ȼ$TMPŹб·, 
        #+ "򻯵"(shortcutting the circuit)ֹ±ߵ --exclude '*'. 

    echo "Done"

    rm -f $PID_FILE 2>/dev/null

    return $RET
}

# -------
# Main
init
check_pid
set_range
get_list
get_file
RET=$?
# -------

if [ "$RET" -eq 0 ]; then
    /usr/bin/logger -t ${0##*/} "Fedora update mirrored successfully."
else
    /usr/bin/logger -t ${0##*/} "Fedora update mirrored with failure code: $RET"
fi

exit $RET
